<?php

// ========================================================================== //

    function info_component_forum(){
$inDB = cmsDatabase::getInstance();
$version = $inDB->get_field('cms_components', "link = 'forum'", 'version');
if($version == '1.5')$inDB->query("UPDATE cms_components SET `version` = '1.0' WHERE link = 'forum'");
        //Описание компонента

        $_component['title']        = 'Форум';
        $_component['description']  = 'Обновление форума от lokanaft-а';
        $_component['link']         = 'forum';
        $_component['author']       = 'InstantCMS team';
        $_component['internal']     = '0';
        $_component['version']      = '1.10b';

        //Настройки по-умолчанию

        $_component['config'] = array(
                'is_rss' => 1,
                'pp_thread' => 15,
                'pp_forum' => 15,
                'showimg' => 1,
                'img_on' => 1,
                'img_max' => 5,
                'fast_on' => 1,
                'fast_bb' => 1,
                'fa_on' => 1,
                'group_access' => '',
                'fa_max' => 25,
                'fa_ext' => 'txt doc zip rar arj png gif jpg jpeg bmp',
                'fa_size' => 1024,
                'edit_minutes' => 0,
                'watermark' => 0,
                'act_thr' => 100,
                'act_thr_pp' => 20,
                'act_pst' => 100,
                'act_pst_pp' => 20,
                'vote_on' => 1,
                'show_sort' => 1,
                'show_moders' => 1,
                'rank_on' => 1,
                'only_rank' => 1,
                'show_post_count' => 1,
                'show_city' => 1,
                'del_adm_post' => 0,
                'del_smdr_post' => 0,
                'hide_del_thr' => 1,
                'hide_del_post' => 1,
                'pin_fpost_on' => 0
        );

        return $_component;

    }

// ========================================================================== //

    function upgrade_component_forum(){
        
        $inCore     = cmsCore::getInstance();       //подключаем ядро
        $inDB       = cmsDatabase::getInstance();   //подключаем базу данных
        cmsCore::loadModel('forum');
        $model = new cms_model_forum();

$recycle = $inDB->get_field('cms_forums', "description = 'recycle'", 'id');
if(!$recycle)$inDB->addNsCategory('cms_forums', array('category_id'=>'1',
                                             'parent_id'=>'1000',
                                             'title'=>'Корзина',
                                             'description'=>'recycle',
                                             'access_list'=>'',
                                             'moder_list'=>'',
                                             'published'=>0,
                                             'icon'=>'recycle_f.png',
                                             'topic_cost'=>0));

        if (!$inDB->num_rows($inDB->query("SHOW INDEX FROM `cms_forums` WHERE Column_name = 'access_list'"))){
            $inDB->query("ALTER TABLE `cms_forums` ADD FULLTEXT (`access_list`)");
        }
        if (!$inDB->isFieldExists('cms_forum_threads', 'editdate')){
            $sql = "ALTER TABLE `cms_forum_threads` ADD `editdate` DATETIME NOT NULL AFTER `pubdate`";
            $inDB->query($sql);
        }
        if (!$inDB->isFieldExists('cms_forum_posts', 'it_fpost')){
            $sql = "ALTER TABLE `cms_forum_posts` ADD `it_fpost` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `user_id`";
            $inDB->query($sql);
        }
        if (!$inDB->isFieldExists('cms_forum_posts', 'is_del')){
            $sql = "ALTER TABLE `cms_forum_posts` ADD `is_del` TINYINT( 1 ) NOT NULL DEFAULT '0'";
            $inDB->query($sql);
        }
        if (!$inDB->isFieldExists('cms_forum_threads', 'fid_b4del')){
            $sql = "ALTER TABLE `cms_forum_threads` ADD `fid_b4del` INT NOT NULL AFTER `forum_id`";
            $inDB->query($sql);
        }
        if (!$inDB->isFieldExists('cms_forum_posts', 'reasons')){
            $sql = "ALTER TABLE `cms_forum_posts` ADD `reasons` TEXT NOT NULL AFTER `edittimes`";
            $inDB->query($sql);
        }
        if (!$inDB->isFieldExists('cms_users', 'last_logdate')){
            $sql = "ALTER TABLE `cms_users` ADD `last_logdate` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `logdate`";
            $inDB->query($sql);
            $inDB->query("UPDATE `cms_users` SET `last_logdate` = logdate");
        }
        

$threads = $inDB->query("SELECT id FROM `cms_forum_threads`");
if ($inDB->num_rows($threads) > 0){
while($thread = $inDB->fetch_assoc($threads)){
$fpost = $inDB->query("SELECT pubdate 
FROM `cms_forum_posts` 
WHERE `thread_id` = '{$thread['id']}'
ORDER BY `pubdate` ASC 
LIMIT 1");
if ($inDB->num_rows($fpost)){
$data = mysql_fetch_assoc($fpost);
$inDB->query("UPDATE `cms_forum_threads` SET `pubdate` = '{$data['pubdate']}' WHERE `id` = '{$thread['id']}'");      
}
}
}

$result = $inDB->query("SELECT id FROM cms_forum_threads");

        if ($inDB->num_rows($result)){
            while($thread = $inDB->fetch_assoc($result)){

                $model->updateThreadPostCount($thread['id']);
                $model->cacheThreadLastPost($thread['id']);

            }
        }

$forums = $inDB->query("SELECT id, NSLeft, NSRight FROM `cms_forums`");
if ($inDB->num_rows($forums) > 0){
while($forum = $inDB->fetch_assoc($forums)){
$model->updateForumCache($forum['NSLeft'], $forum['NSRight']);
}
}

return true;


}

// ========================================================================== //
